Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
[SMPI] Update notice in smpirun.in for cluster tags.
[simgrid.git] / src / smpi / smpirun.in
index 1d80693..97fad0b 100755 (executable)
 SIMGRID_VERSION="@SIMGRID_VERSION_STRING@"
 SIMGRID_GITHASH="@SIMGRID_GITHASH@"
 
-DEFAULT_LOOPBACK_BANDWIDTH="498000000"
-DEFAULT_LOOPBACK_LATENCY="0.000004"
-DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))"
-DEFAULT_NETWORK_LATENCY="0.000005"
+DEFAULT_LOOPBACK_BANDWIDTH="498000000Bps"
+DEFAULT_LOOPBACK_LATENCY="0.000004s"
+DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))Bps"
+DEFAULT_NETWORK_LATENCY="0.000005s"
 DEFAULT_NUMPROCS="4"
-DEFAULT_POWER="100"
+DEFAULT_SPEED="100flops"
 
 LOOPBACK_BANDWIDTH="${DEFAULT_LOOPBACK_BANDWIDTH}"
 LOOPBACK_LATENCY="${DEFAULT_LOOPBACK_LATENCY}"
 NETWORK_BANDWIDTH="${DEFAULT_NETWORK_BANDWIDTH}"
 NETWORK_LATENCY="${DEFAULT_NETWORK_LATENCY}"
-POWER="${DEFAULT_POWER}"
+SPEED="${DEFAULT_SPEED}"
 
-SIMOPTS="--cfg=surf/precision:1e-9 --cfg=network/model:SMPI --cfg=network/TCP_gamma:4194304"
+SIMOPTS="--cfg=surf/precision:1e-9 --cfg=network/model:SMPI --cfg=network/TCP-gamma:4194304"
 
 #usage to print the way this script should be called
 usage () {
@@ -45,10 +45,6 @@ Options:
   -trace-viva                # generate configuration for Viva's GraphView
   -trace-file <tracefile>    # name of the tracefile (simgrid_smpi.trace)
   -ext <value>               # additional parameter (reserved)
-  -foreground                # run the child process in the foreground:
-                             # - it can access the terminal;
-                             # - but we cannot stop it when we receive a signal.
-                             # This is useful with -wrapper "gdb --args".
 
   -version                   # Displays the SimGrid version (human readable)
   -git-version               # Displays the git hash of SimGrid
@@ -72,7 +68,6 @@ HOSTFILE=""
 HOSTFILETMP=0
 
 unset pid
-unset foreground ; foreground=0
 
 trapped_signals="HUP INT QUIT ILL ABRT SEGV FPE ALRM TERM USR1 USR2 BUS"
 
@@ -152,7 +147,6 @@ while true; do
             fi
            shift 2
             ;;
-
         "-machinefile")
            HOSTFILE="$2"
             if [ ! -f "${HOSTFILE}" ]; then
@@ -161,83 +155,67 @@ while true; do
             fi
            shift 2
             ;;
-
         "-ext")
             EXTOPT="$2"
             shift 2
             ;;
-
         "-map")
            MAPOPT="true"
             shift 1
             ;;
-
         "-trace")
             TRACE_ACTIVE="true"
             shift 1
             ;;
-
         "-trace-ti")
             TRACE_ACTIVE="true"
             TRACE_TI_ACTIVE="true"
             shift 1
             ;;
-
         "-trace-comment")
             TRACE_COMMENT="$2"
             shift 2
             ;;
-
         "-trace-comment-file")
             TRACE_COMMENT_FILE="$2"
             shift 2
             ;;
-
         "-trace-file")
             TRACE_FILENAME="$2"
             shift 2
             ;;
-
         "-trace-grouped")
             TRACE_GROUPED="true"
             shift 1
             ;;
-
         "-trace-resource")
             TRACE_RESOURCE="true"
             shift 1
             ;;
-
         "-trace-viva")
            TRACE_VIVA="true"
            shift 1
             ;;
-
         "-keep-temps")
            KEEP="true"
             shift 1
             ;;
-
         "-wrapper")
             WRAPPER="$2"
             shift 2
             ;;
-
         "-help" | "--help" | "-h")
             usage
             exit 0
             ;;
-
         "-version" | "--version" | "-v")
             printf '%b\n' "$SIMGRID_VERSION"
             exit 0
             ;;
-           
         "-git-version" | "--git-version")
             printf '%b\n' "$SIMGRID_GITHASH"
             exit 0
             ;;
-
         "--cfg="*|"--log="*)
             for OPT in ${1#*=}
             do
@@ -246,7 +224,7 @@ while true; do
             shift 1
             ;;
         "-foreground")
-            foreground=1
+            # Nothing to do, compatibility.
             shift 1
             ;;
         *)
@@ -279,10 +257,6 @@ while [ $# -gt 0 ]; do
     esac
 done
 
-
-##-----------------------------------
-
-
 if [ -z "${HOSTFILE}" ] && [ -z "${PLATFORM}" ] ; then
     echo "No hostfile nor platform specified."
     usage
@@ -291,7 +265,7 @@ fi
 
 if [ -z "${HOSTFILE}" ] ; then
     HOSTFILETMP=1
-    HOSTFILE="$(mktemp tmphostXXXXXX)"
+    HOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
     perl -ne 'print "$1\n" if /.*<host.*?id="(.*?)".*?\/>.*/' ${PLATFORM} > ${HOSTFILE}
     perl -ne 'if (/.*<cluster.*?prefix="(.*?)".*?radical="(.*?)".*?suffix="(.*?)".*/) { 
                 my ($pre,$rad,$post)=($1,$2,$3); 
@@ -305,7 +279,7 @@ if [ -z "${HOSTFILE}" ] ; then
                  }
                }
              } elsif (/<cluster/) {
-               die ("Unparsable cluster tag. Either provide an hostfile yourself or give the attributes prefix, radical and suffix in that order on the <cluster line");
+            die ("Unparsable cluster tag. smpirun uses a primitive regular expression to parse cluster tags. Either provide a hostfile yourself or give the attributes prefix, radical and suffix IN THAT ORDER and ON THE SAME LINE as the opening tag (<cluster)");
              }' ${PLATFORM} >> ${HOSTFILE}
 fi
 UNROLLEDHOSTFILETMP=0
@@ -314,7 +288,7 @@ UNROLLEDHOSTFILETMP=0
 multiple_processes=`grep -c ":" $HOSTFILE`
 if [ "${multiple_processes}" -gt 0 ] ; then
     UNROLLEDHOSTFILETMP=1
-    UNROLLEDHOSTFILE="$(mktemp tmphostXXXXXX)"
+    UNROLLEDHOSTFILE="$(mktemp smpitmp-hostfXXXXXX)"
     perl -ne ' do{ for ( 1 .. $2 ) { print "$1\n" } } if /(.*?):(\d+).*/'  ${HOSTFILE}  > ${UNROLLEDHOSTFILE}
     if [ ${HOSTFILETMP} = 1 ] ; then
         rm ${HOSTFILE}
@@ -323,7 +297,6 @@ if [ "${multiple_processes}" -gt 0 ] ; then
     HOSTFILE=$UNROLLEDHOSTFILE
 fi
 
-
 # Don't use wc -l to compute it to avoid issues with trailing \n at EOF
 hostfile_procs=`grep -c "[a-zA-Z0-9]" $HOSTFILE`
 if [ ${hostfile_procs} = 0 ] ; then
@@ -336,25 +309,24 @@ if [ -z "${NUMPROCS}" ] ; then
     NUMPROCS=$hostfile_procs
 fi
 
-
 if [ ${NUMPROCS} -gt ${hostfile_procs} ] ; then
     echo "You requested to use ${NUMPROCS} processes, but there is only ${hostfile_procs} processes in your hostfile..." >&2
 fi
 
 ##-------------------------------- DEFAULT or SPECIFIED PLATFORM --------------------------------------
 if [ -z "${PLATFORM}" ]; then
-    PLATFORMTMP="$(mktemp tmpXXXXXX)"
+    PLATFORMTMP="$(mktemp smpitmp-platfXXXXXX)"
 
     cat > ${PLATFORMTMP} <<PLATFORMHEAD
 <?xml version='1.0'?>
-<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid.dtd">
-<platform version="3">
+<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
+<platform version="4">
 <AS id="AS0" routing="Full">
 PLATFORMHEAD
 
     i=${NUMPROCS}
     while [ $i -gt 0 ]; do
-        echo "  <host id=\"host$i\" power=\"${POWER}\"/>" >> ${PLATFORMTMP}
+        echo "  <host id=\"host$i\" speed=\"${SPEED}\"/>" >> ${PLATFORMTMP}
         echo "  <link id=\"loop$i\" bandwidth=\"${LOOPBACK_BANDWIDTH}\" latency=\"${LOOPBACK_LATENCY}\"/>" >> ${PLATFORMTMP}
         echo "  <link id=\"link$i\" bandwidth=\"${NETWORK_BANDWIDTH}\" latency=\"${NETWORK_LATENCY}\"/>" >> ${PLATFORMTMP}
         i=$((i - 1))
@@ -383,16 +355,14 @@ else
     PLATFORMTMP=${PLATFORM}
 fi
 ##-------------------------------- end DEFAULT or SPECIFIED PLATFORM --------------------------------------
-
 ##-------------------------------- DEFAULT APPLICATION --------------------------------------
-APPLICATIONTMP="$(mktemp tmpXXXXXX)"
+APPLICATIONTMP="$(mktemp smpitmp-appXXXXXX)"
 #APPLICATIONTMP="app.xml"
 
-
 cat > ${APPLICATIONTMP} <<APPLICATIONHEAD
 <?xml version='1.0'?>
-<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid.dtd">
-<platform version="3">
+<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid/simgrid.dtd">
+<platform version="4">
 APPLICATIONHEAD
 
 ##---- cache hostnames of hostfile---------------
@@ -407,15 +377,14 @@ if [ "${EXTOPT}" = "smpi_replay" ]; then
         hosttraces=$(cat ${APP_TRACES} | tr '\n\r' '  ' )
         NUMTRACES=$(cat ${APP_TRACES} | wc -l)
     else
-        printf "File not found: %s\n", "${APP_TRACES:-\${APP_TRACES\}}" >&2
+        printf "File not found: %s\n" "${APP_TRACES:-\${APP_TRACES\}}" >&2
         exit 1
     fi
 fi
 
 ##----------------------------------------------------------
 ##  generate application.xml with hostnames from hostfile:
-##  the name of host_i (1<=i<=p, where -np p) is the line i
-##  in hostfile (where -hostfile hostfile), or "host$i" if
+##  the name of host_i (1<=i<=p, where -np p) is the line i in hostfile (where -hostfile hostfile), or "host$i" if 
 ##  hostfile has less than i lines.
 ##----------------------------------------------------------
 
@@ -432,7 +401,6 @@ else
 fi
 
 ##---- generate <process> tags------------------------------
-
 for i in ${SEQ}
 do
     if [ -n "${HOSTFILE}" ]; then
@@ -469,7 +437,6 @@ cat >> ${APPLICATIONTMP} <<APPLICATIONFOOT
 </platform>
 APPLICATIONFOOT
 ##-------------------------------- end DEFAULT APPLICATION --------------------------------------
-
 ##---------------------- SMPI TRACING OPTIONS ---------------------------------
 if [ -n "${TRACE_ACTIVE}" ]; then
     #define trace filename
@@ -490,7 +457,7 @@ if [ -n "${TRACE_ACTIVE}" ]; then
     fi
 
     if [ -n "${TRACE_COMMENT_FILE}" ]; then
-        TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment_file:${TRACE_COMMENT_FILE}"
+        TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment-file:${TRACE_COMMENT_FILE}"
     fi
 
     if [ -n "${TRACE_GROUPED}" ]; then
@@ -517,16 +484,24 @@ if [ -n "${KEEP}" ] ; then
         echo "Generated unrolled hostfile ${UNROLLEDHOSTFILE} kept." 
     fi
 fi
-if [ "$foreground" = 1 ]; then
-  ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP}
-  status=$?
-else
-  ${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP} &
-  pid=$!
-  wait $pid
-  status=$?
-  pid=""
-fi
+
+# Execute the process
+#
+# The shell still need to be alive for the duration in order to do some cleanup after the process.
+#
+# We are going through great lengths in order to both keep stdin and be able to handle signals:
+#
+# * The job is launched in the background in order to be able to handle signals.
+#
+# * The FD 3 is used to temporarily store FD 1. This is because the shell connects FD 1 to /dev/null when the command
+#   is launched in the background: this can be overriden in bash but not in standard bourne shell.
+exec 3<&0
+${EXEC} ${TRACEOPTIONS} ${SIMOPTS} ${PLATFORMTMP} ${APPLICATIONTMP} <&3 3>&- &
+pid=$!
+exec 3>&-
+wait $pid
+status=$?
+pid=""
 
 smpirun_cleanup